"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require("@angular/core");
var SpreadSheetsComponent = (function () {
    function SpreadSheetsComponent(elRef) {
        this.elRef = elRef;
    }
    SpreadSheetsComponent.prototype.ngOnDestroy = function () {
        this.workbook.destroy();
    };
    SpreadSheetsComponent.prototype.ngOnInit = function () {
        var dom = this.elRef.nativeElement;
        if (!this.workbook) {
            var hostElement = dom.getElementsByTagName('div')[0];
            this.workbook = new GC.Spread.Sheets.Workbook(hostElement, this.options || {});
            this.applySheetsOptions(this.options);
        }
    };
    SpreadSheetsComponent.prototype.applySheetsOptions = function (options) {
        var sheets = this.workbook.sheets;
        var sheetOptions = options.sheets;
        if (sheetOptions) {
            for (var i = 0; i < sheetOptions.length; i++) {
                var sheetOption = sheetOptions[i];
                if (!sheets[i] || !sheetOption)
                    break;
                this.applySheetOption(sheets[i], sheetOption);
            }
        }
    };
    SpreadSheetsComponent.prototype.applySheetOption = function (sheet, sheetOption) {
        for (var option in sheetOption) {
            if (option === 'name') {
                sheet.name(sheetOption.name);
            }
            else if (option === 'dataSource') {
                sheet.setDataSource(sheetOption.dataSource);
            }
            else if (option === 'columns') {
                var columns = sheetOption.columns;
                columns.forEach(function (column, index) {
                    if (column.dataField) {
                        sheet.bindColumn(index, {
                            name: column.dataField,
                            displayName: column.headerText,
                            formatter: column.formatter
                        });
                    }
                    if (!isNaN(column.width)) {
                        sheet.setColumnWidth(index, column.width);
                    }
                });
                sheet.setColumnCount(columns.length);
            }
            else {
                sheet.options[option] = sheetOption[option];
            }
        }
    };
    SpreadSheetsComponent.prototype.ngOnChanges = function (changes) {
        if (!this.workbook)
            return;
        var options = changes['options'] && changes['options'].currentValue;
        if (options) {
            this.workbook.clearSheets();
            // apply workbook options
            for (var option in options) {
                if (option === 'sheets') {
                    continue;
                }
                else if (option === 'sheetCount') {
                    this.workbook.setSheetCount(options[option]);
                }
                else {
                    this.workbook.options[option] = options[option];
                }
            }
            // apply sheets options
            if (options['sheets']) {
                this.applySheetsOptions(options['sheets']);
            }
        }
    };
    return SpreadSheetsComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], SpreadSheetsComponent.prototype, "options", void 0);
SpreadSheetsComponent = __decorate([
    core_1.Component({
        selector: 'spread-sheets',
        template: "\n              <div style=\"width:100%;height:100%;\">\n              </div>\n            "
    }),
    __param(0, core_1.Inject(core_1.ElementRef)),
    __metadata("design:paramtypes", [core_1.ElementRef])
], SpreadSheetsComponent);
exports.SpreadSheetsComponent = SpreadSheetsComponent;
//# sourceMappingURL=spreadSheets.component.js.map