"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var spreadSheets_component_1 = require("./spread/spreadSheets.component");
var AppComponent = (function () {
    function AppComponent() {
        var data = [];
        var countries = ["US", "Germany", "UK", "Japan", "Italy"];
        var products = ["Widget", "Gadget", "Doohickey"];
        var count = 50;
        for (var i = 0; i < count; i++) {
            var item = {
                country: countries[Math.floor(Math.random() * countries.length)],
                product: products[Math.floor(Math.random() * products.length)],
                amount: 1000 + Math.random() * 10000,
                date: new Date()
            };
            data.push(item);
        }
        this.options = {
            backColor: "white",
            grayAreaBackColor: "lightgray",
            sheetCount: 2,
            sheets: [{
                    name: "Sales",
                    dataSource: data,
                    columns: [
                        { dataField: "date", headerText: "Date", formatter: "dd/mm/yyyy", width: 100, },
                        { dataField: "country", headerText: "Country", width: 120 },
                        { dataField: "product", headerText: "Product", width: 150 },
                        { dataField: "amount", headerText: "Sale Amount", width: 150, formatter: "$0,###.00" }
                    ]
                }, {
                    name: "Aggregation",
                    rowHeaderVisible: false,
                    selectionBackColor: 'yellow'
                }
            ]
        };
    }
    AppComponent.prototype.ngAfterViewInit = function () {
        var self = this;
        // workbook object is available now.
        var workbook = self.spread.workbook;
        // More init ...
        var sheet = workbook.sheets[1];
        sheet.setRowCount(20, 3);
        sheet.setColumnCount(10, 3);
        sheet.setValue(0, 1, "Total:");
        sheet.setFormula(1, 1, "sum(Sales!D:D)");
        workbook.bind("CellClick", function (s, e) {
            self.message = s.type + "\n" + JSON.stringify({ sheet: e.sheet.name(), row: e.row, column: e.col, sheetArea: e.sheetArea }, null, 4);
        });
        workbook.bind("TopRowChanged", function (s, e) {
            self.message = s.type + "\n" + JSON.stringify({ sheet: e.sheet.name(), oldTopRow: e.oldTopRow, newTopRow: e.newTopRow }, null, 4);
        });
    };
    return AppComponent;
}());
__decorate([
    core_1.ViewChild('ss'),
    __metadata("design:type", spreadSheets_component_1.SpreadSheetsComponent)
], AppComponent.prototype, "spread", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], AppComponent.prototype, "options", void 0);
AppComponent = __decorate([
    core_1.Component({
        selector: 'my-app',
        template: "\n    <div style=\"width:800px; height:400px; border:1px solid black;\">\n        <spread-sheets #ss [options] = \"options\"></spread-sheets>      \n    </div>\n    <h3>Events</h3>\n    <div>{{message}}<div>\n    "
    }),
    __metadata("design:paramtypes", [])
], AppComponent);
exports.AppComponent = AppComponent;
//# sourceMappingURL=app.component.js.map